<template>
   <div>
     <h6 v-if="showTitle" style="text-align: center;">{{rawData.Title}}</h6>
     <apexchart width="100%" type="radialBar" :options="chartOptions" :series="chartData"></apexchart>
   </div>
</template>

<script>

export default {
  props: {
    rawData: {
      required: true
    },
    showTitle: {
      required: true
    }
  },
  computed: {
    chartOptions: function() {

      let labels = [];

      for(let i = 0; i < Object.keys(this.rawData.Options).length; i++)
      {
        labels.push(this.rawData.Options[i].Text);
      }

      return {
        chart: {
          height: 350,
          type: 'radialBar',
        },
        legend: {
          show: true,
          position: 'bottom',
          horizontalAlign: 'center', 
          onItemClick: {
            toggleDataSeries: false
          },
          onItemHover: {
              highlightDataSeries: true
          },
          formatter: (label, opts) => {
            return this.legendEntry(label, opts.seriesIndex);
          }
        },
        plotOptions: {
          radialBar: {
            dataLabels: {
              name: {
                show: true,
                fontSize: '16px',
                fontFamily: undefined,
                fontWeight: 600,
                color: undefined,
                offsetY: -10,
                background: {
                  show: true,
                  foreColor: 'red',
                  borderRadius: 2,
                  borderWidth: 1,
                  borderColor: '#fff',
                },
              },
              value: {
                show: true,
                fontSize: '14px',
                fontWeight: 400,
                offsetY: 16,
                background: 'white',
                formatter: (val) => {
                  let voteCount = Math.round(val / 100 * this.totalVotes);
                  return this.$t(voteCount == 1 ? "poll.single_vote" : "poll.many_votes", [voteCount]);
                }
              },
              total: {
                  show: true,
                  label: 'Total',
                  color: '#373d3f',
                  fontSize: '16px',
                  fontFamily: undefined,
                  fontWeight: 600,
                  formatter: () => {
                    return this.$t(this.totalVotes == 1 ? "poll.single_vote" : "poll.many_votes", [this.totalVotes]);
                  }
                }
            }
          },
        },
        labels: labels
      } 
    },
    totalVotes()
    {
      return Object.keys(this.rawData?.Results ?? {}).length;
    },
    chartData() 
    {
      let percentSeries = [];

      for(let i = 0; i < Object.keys(this.rawData.Options).length; i++)
      {
        percentSeries.push(0)
      }

      if(this.rawData.Results)
      {
        for(let num in this.rawData.Results)
        {
          percentSeries[this.rawData.Results[num].Vote] += 1;
        }

        for(let i = 0; i < percentSeries.length; i++)
        {
          percentSeries[i] = (percentSeries[i] / this.totalVotes) * 100
        }
      }

      return percentSeries;
    }
  },
  watch: {

  },
  methods: {
    legendEntry(label, seriesIndex) {
      let thisVal = this.chartData[seriesIndex];
      let voteCount = isNaN(thisVal) ? 0 : Math.round(thisVal / 100 * this.totalVotes);
      return this.$t(voteCount == 1 ? 'poll.legend_single' : 'poll.legend_plural', [
        label,
        isNaN(thisVal) ? 0 : Math.round(thisVal),
        voteCount
      ]);
    }
  }
};
</script>